# This file is a template, and might need editing before it works on your project.
# Official language image. Look for the different tagged releases at:
# https://hub.docker.com/r/library/rust/tags/
image: "rust:1.52.1"

stages:
  - test
  - build
  - package
  - deploy


# Optional: Pick zero or more services to be used on all builds.
# Only needed when using a docker container to run your tests in.
# Check out: http://docs.gitlab.com/ee/ci/docker/using_docker_images.html#what-is-a-service
# services:
#   - mysql:latest
#   - redis:latest
#   - postgres:latest

# Optional: Install a C compiler, cmake and git into the container.
# You will often need this when you (or any of your dependencies) depends on C code.
# before_script:
#   - apt-get update -yqq
#   - apt-get install -yqq --no-install-recommends build-essential

cache:
  paths:
    - /usr/local/cargo
    - target

# Use cargo to test the project
test:cargo:
  stage: test
  rules:
    - when: always
  script:
    - rustc --version && cargo --version  # Print version info for debugging
    - cargo test --workspace --verbose

build:cargo:
  stage: build
  only:
    - main
  script:
    - cargo build --release
  needs:
    - test:cargo

package:upload:
  image: curlimages/curl:latest
  stage: package
  only:
    - main
  needs:
    - build:cargo
  script:
    - 'curl --header "JOB-TOKEN: $CI_JOB_TOKEN" --upload-file target/release/escape-room "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/escaperoom_service/${CI_COMMIT_REF_NAME}/escape-room"'

deploy:main:
  image: ubuntu:latest
  stage: deploy
  environment:
    name: Production
    url: https://escape-room.kennsla.drentec.de
  only:
    - main
  needs:
    - build:cargo
  before_script:
    - 'command -v ssh-agent >/dev/null || ( apt-get update -y && apt-get install openssh-client -y )'
    - eval $(ssh-agent -s)
    - echo "${SSH_PRIVATE_KEY}" | tr -d '\r' | ssh-add - > /dev/null
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'

  script:
    - ssh drentec@drentec.de "/home/drentec/bin/deploy --project=escape-room --id=$CI_COMMIT_SHA"

deploy:branch:
  image: ubuntu:latest
  stage: deploy
  environment:
    name: review/$CI_COMMIT_REF_NAME
    url: https://$CI_ENVIRONMENT_SLUG.escape-room.kennsla.drentec.de
    on_stop: stop_review
    auto_stop_in: 1 week
  rules:
    - if: $CI_MERGE_REQUEST_ID
  needs:
    - test:cargo
  before_script:
    - 'command -v ssh-agent >/dev/null || ( apt-get update -y && apt-get install openssh-client -y )'
    - eval $(ssh-agent -s)
    - echo "${SSH_PRIVATE_KEY}" | tr -d '\r' | ssh-add - > /dev/null
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'

  script:
    - ssh drentec@drentec.de "/home/drentec/bin/deploy --project=escape-room --id=$CI_COMMIT_SHA --preview=$CI_ENVIRONMENT_SLUG"

stop_review:
  image: ubuntu:latest
  stage: deploy
  environment:
    name: review/$CI_COMMIT_REF_NAME
    action: stop
  rules:
    - if: $CI_MERGE_REQUEST_ID
      when: manual
  before_script:
    - 'command -v ssh-agent >/dev/null || ( apt-get update -y && apt-get install openssh-client -y )'
    - eval $(ssh-agent -s)
    - echo "${SSH_PRIVATE_KEY}" | tr -d '\r' | ssh-add - > /dev/null
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'

  script:
    - ssh drentec@drentec.de "/home/drentec/bin/rm-preview-deployment --project=escape-room --name=$CI_ENVIRONMENT_SLUG"
